﻿//-----------------------------------------------
//TUSB-K02AD(V)用ドライバアクセス用API
//Visual C# 用モジュール
//
//2013_12_16　株式会社タートル工業
//Copyright (C) 2013 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;


class TUSBK02AD
{
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_Device_Open(short Id);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void TUSBK02AD_Device_Close(short Id);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_Ad_Single(short Id, byte Ch, out short Dat);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_Ad_Start(short Id, byte Ch,byte TrgCh,int Clk);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_Ad_Stop(short Id);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_DIO_Dir(short Id, byte b, byte direction);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_DIO_In(short Id, out byte data);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_DIO_Out(short Id, byte b, byte data);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_DIO_Status(short Id, [Out] byte[] data);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern double TUSBK02AD_ExtTimer(int Clk);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_ExtTimer_Set(short Id, int Clk);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_Get_Data(short Id, [Out] short[] dat1,[Out] short[] dat2, ref int Leng);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_Get_Status(short Id, out byte Status, out int Leng);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern double TUSBK02AD_IntClk(int Clk);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_Trigger_Set(short Id, byte TrgType, short Level, short Hys, int PreLen);
    [DllImport("TUSK02AD.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK02AD_SoftTrigger(short Id);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            case 10:
                return "メモリ領域が確保できません";
            case 11:
                return "連続取込動作中です";
            case 12:
                return "連続取り込みデータはありません";
            case 13:
                return "開始されていません";
            case 14:
                return "メモリオーバーフロー";
            case 15:
                return "データ並びエラー";
            default:
                return "不明なエラーです";
        }
    }
}


