'-----------------------------------------------
'API for TUSB-K02AD Driver
'Visual Basic Module
'
'Apr. 04 2012
'Copyright (C) 2012 Turtle Industry Co.,Ltd.
'-----------------------------------------------
Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Module TUSBK02AD

	'API Function declaration

    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_Device_Open(ByVal Id As Short) _
    As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub TUSBK02AD_Device_Close(ByVal Id As Short)
    End Sub
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_Ad_Single(ByVal Id As Short, _
                                 ByVal Ch As Byte, _
                                 ByRef Dat As Short) _
                             As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_Ad_Start(ByVal Id As Short, _
                                ByVal Ch As Byte, _
                                ByVal TrgCh As Byte, _
                                ByVal Clk As Integer) _
                            As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_Ad_Stop(ByVal Id As Short) _
    As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_DIO_Dir(ByVal Id As Short, _
                               ByVal b As Byte, _
                               ByVal direction As Byte) _
                           As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_DIO_In(ByVal Id As Short, _
                              ByRef data As Byte) _
                          As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_DIO_Out(ByVal Id As Short, _
                               ByVal b As Byte, _
                               ByVal data As Byte) _
                           As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_DIO_Status(ByVal Id As Short, _
                                  <[In](), Out()> ByVal data() As Byte) _
                              As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_ExtTimer(ByVal Clk As Integer) _
    As Double
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_ExtTimer_Set(ByVal Id As Short, _
                                    ByVal Clk As Integer) _
                                As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_Get_Data(ByVal Id As Short, _
                                <[In](), Out()> ByVal dat1() As Short, _
                                <[In](), Out()> ByVal dat2() As Short, _
                                ByRef Leng As Integer) _
                            As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_Get_Status(ByVal Id As Short, _
                                  ByRef Status As Byte, _
                                  ByRef Leng As Integer) _
                              As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_IntClk(ByVal Clk As Integer) _
    As Double
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_Trigger_Set(ByVal Id As Short, _
                                   ByVal TrgType As Byte, _
                                   ByVal Level As Short, _
                                   ByVal Hys As Short, _
                                   ByVal PreLen As Integer) _
                               As Short
    End Function
    <DllImport("TUSK02AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK02AD_SoftTrigger(ByVal Id As Short) _
    As Short
    End Function

    ' Error Message
    Public Sub TUSBK02AD_ErrorDisp(ByVal ErrCode As Short)
        Dim tmpStr As String

        Select Case ErrCode
            Case 0
                tmpStr = "ɏI܂"
            Case 1
                tmpStr = "IDԍsł"
            Case 2
                tmpStr = "hCoĂ܂"
            Case 3
                tmpStr = "łɃfoCX̓I[vĂ܂"
            Case 4
                tmpStr = "ڑĂ䐔܂"
            Case 5
                tmpStr = "I[vł܂ł"
            Case 6
                tmpStr = "foCX܂ł"
            Case 7
                tmpStr = "I[vĂ܂"
            Case 8
                tmpStr = "p[^G["
            Case 9
                tmpStr = "USBʐMG["
            Case 10
                tmpStr = "̈悪mۂł܂"
            Case 11
                tmpStr = "A捞쒆ł"
            Case 12
                tmpStr = "A荞݃f[^͂܂"
            Case 13
                tmpStr = "JnĂ܂"
            Case 14
                tmpStr = "I[o[t["
            Case 15
                tmpStr = "f[^уG["
            Case Else
                tmpStr = "sȃG[ł"
        End Select

        MessageBox.Show(tmpStr)
    End Sub
End Module